<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelMetaDiaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function findMetaDia($CDFILIAL, $DTENTRVENDAINI, $DTENTRVENDAFIN, $DIA, $NRORG) {
        $params = array(
         	":CDFILIAL" => $CDFILIAL,
         	":DTENTRVENDAINI" => $DTENTRVENDAINI,
            ":DTENTRVENDAFIN" => $DTENTRVENDAFIN,
         	":DIA" => $DIA,
         	":NRORG" => $NRORG
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_META_DIA_FATURAMENTO, $params);
    }
  
    const GET_META_DIA_FATURAMENTO = "
        SELECT A.*, 
               (A.VALOR_FATURAMENTO - A.VRDESITVEND + A.VRACRITVEND) AS VALOR_VENDIDO,
               ((A.VALOR_FATURAMENTO - A.VRDESITVEND + A.VRACRITVEND) - A.VRMETADIA) AS VRMENOSMETA,
               TRUNC(((A.VALOR_FATURAMENTO - A.VRDESITVEND + A.VRACRITVEND)/(A.VRMETADIA)*100),2) AS PERCENTUAL,
               TRUNC(((A.VALOR_FATURAMENTO - A.VRDESITVEND + A.VRACRITVEND)/(A.NRPESMESAVENDA)),2) AS TCKMED,
               TRUNC(((A.VALOR_FATURAMENTO - A.VRDESITVEND + A.VRACRITVEND)/(A.NRPESMESAVENDA)/(A.VRTCKMED)*100),2) AS PERCTCKMED
        FROM(
            SELECT FILOCAVE.CDFILIAL, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.NMFILIAL, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL,
                  FILOCAVE.NRPESMESAVENDA AS NRPESMESAVENDA, FILOCAVE.VRMETADIA, FILOCAVE.VRTCKMED,
                  TO_CHAR(FILOCAVE.DATA, 'D') AS DIA,
                  TO_CHAR(FILOCAVE.DATA, 'DD/MM/YYYY') AS DATA,
                  SUM(NVL(I.VRDESITVEND, 0)) AS VRDESITVEND,
                  CASE FILOCAVE.IDSITUVENDA
                      WHEN 'C' THEN 0
                      ELSE SUM(TRUNC(NVL(I.VRACRITVEND, 0), 2))
                  END AS VRACRITVEND,
                  CASE FILOCAVE.IDSITUVENDA
                      WHEN 'C' THEN 0
                      ELSE SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2))
                  END AS VALOR_FATURAMENTO
             FROM ITEMVENDA I
             JOIN (
                 SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL,
                              V.DTVENDA, V.DTENTRVENDA, FILOCA.NMFILIAL, SUM(V.VRREPIQUEVENDA)  OVER (PARTITION BY FILOCA.CDFILIAL, V.DTENTRVENDA)  AS VRREPIQUEVENDA, V.DTABERVENDA,
                              FILOCA.NRORG,  SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.CDFILIAL,FILOCA.DATA) AS NRPESMESAVENDA,
                              TRUNC(FILOCA.VRMETADIA, 2) AS VRMETADIA, FILOCA.VRTCKMED, FILOCA.DATA,
                              V.IDSITUVENDA, V.IDORIGEMVENDA, FILOCA.CDPRODTAXAENTR, FILOCA.IDTRATTAXAENTR, FILOCA.CDPRODTAXASERV, FILOCA.IDTRATTAXASERV, FILOCA.IDCOMISVENDA
                                 FROM VENDA V
                                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.VRMETADIA, FILO.VRTCKMED, FILO.DATA,
                                       FILO.CDPRODTAXAENTR, FILO.IDTRATTAXAENTR, FILO.CDPRODTAXASERV, FILO.IDTRATTAXASERV, FILO.IDCOMISVENDA
                                         FROM CAIXA C
                                         JOIN (SELECT L.CDLOJA, L.NMLOJA, L.IDCOMISVENDA, L.CDPRODTAXAENTR, L.IDTRATTAXAENTR, L.CDPRODTAXASERV, L.IDTRATTAXASERV, FIPA.CDFILIAL, FIPA.NMFILIAL, FIPA.NRORG, FIPA.VRMETADIA, FIPA.VRTCKMED, FIPA.DATA
                                                 FROM LOJA L
                                                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG, CASE M.VRMETADIA WHEN 0 THEN 1 ELSE M.VRMETADIA END AS VRMETADIA , CASE M.VRTCKMED WHEN 0 THEN 1 ELSE M.VRTCKMED END AS VRTCKMED, M.DATA
                                                         FROM FILIAL F
                                                         JOIN METADIAREAL M
                                                           ON F.CDFILIAL = M.CDFILIAL
                                                          AND F.NRORG = M.NRORG
                                                        WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 
                                                          AND F.NRORG =:NRORG 
                                                          AND M.DATA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN) FIPA
                                                   ON L.CDFILIAL = FIPA.CDFILIAL
                                                  AND L.NRORG = FIPA.NRORG) FILO 
                                           ON C.CDFILIAL = FILO.CDFILIAL 
                                          AND C.CDLOJA = FILO.CDLOJA
                                          AND C.NRORG = FILO.NRORG) FILOCA 
                                   ON V.CDCAIXA = FILOCA.CDCAIXA
                                  AND V.CDLOJA = FILOCA.CDLOJA
                                  AND V.CDFILIAL = FILOCA.CDFILIAL
                                  AND V.DTENTRVENDA = FILOCA.DATA
                                  AND V.NRORG = FILOCA.NRORG
                                WHERE V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
                                  AND (INSTR('MES_BAL_DLV_TAA_CMD_AJU_AUT', SUBSTR(V.IDORIGEMVENDA, 0, 3)) > 0 OR INSTR('MES_BAL_DLV_TAA_CMD_AJU_AUT', SUBSTR(V.IDORIGEMVENDA, 5, 7)) > 0)
                ) FILOCAVE
               ON FILOCAVE.CDFILIAL = I.CDFILIAL
              AND FILOCAVE.NRORG = I.NRORG
              AND FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
              AND FILOCAVE.CDCAIXA = I.CDCAIXA
          WHERE FILOCAVE.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
            AND INSTR(:DIA, TO_CHAR(FILOCAVE.DATA, 'D')) > 0
            AND I.CDPRODUTO <> (CASE WHEN (FILOCAVE.IDTRATTAXAENTR = 'P' AND SUBSTR(FILOCAVE.IDORIGEMVENDA, 0, 3) = 'DLV') THEN FILOCAVE.CDPRODTAXAENTR
                                                   ELSE 'ZZZZZZZ'
                                               END)
            AND I.CDPRODUTO <> (CASE WHEN (FILOCAVE.IDTRATTAXASERV = 'P' AND FILOCAVE.IDCOMISVENDA IN ('S', 'G')) THEN FILOCAVE.CDPRODTAXASERV
                                                   ELSE 'ZZZZZZZ'
                                               END)
            AND FILOCAVE.IDSITUVENDA IN(CASE SUBSTR(FILOCAVE.IDORIGEMVENDA, 0, 3)
                                                   WHEN 'AJU' THEN FILOCAVE.IDSITUVENDA
                                                   ELSE 'O'
                                               END)
          GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.NMFILIAL, FILOCAVE.NRPESMESAVENDA, FILOCAVE.VRMETADIA, FILOCAVE.VRTCKMED, FILOCAVE.DATA, FILOCAVE.IDSITUVENDA
          ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DTENTRVENDA)A
    ";
}