<?php

namespace Teknisa\MAN\Services;


use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;


class TabelaDePrecoGeralImportService{ 
    
    protected $conn;
    protected $environment;
    protected $entityManager;
    
    public function controlTransaction($type){
    // controla transação com banco    
        try {
            switch ($type) {
                case 'begin':
                // inicia transação sem auto-commit
                    $this->entityManager->getConnection()->beginTransaction();
                    break;
                case 'commit':
                // salva transação
                    $this->entityManager->getConnection()->commit();
                    break;
                case 'rollback':
                // descarta transação
                    $this->entityManager->getConnection()->rollBack();
                    break;
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function __construct(Connection $conn, Environment $environment, \Doctrine\ORM\EntityManager $entityManager) {
        $this->conn = $conn;
        $this->environment      = $environment;
        $this->entityManager    = $entityManager;
    }
    
    public function saveImportarTabela($dados){
        $retorno = array(
			'status' => true,
			'rowsSucess' => 0,
			'rowsError' => 0,
			'message' => '',
			'logRowsError' => '',
			'logRowsSucess' => ''
		);
		
		$verifDelete = [];
	
		if(!empty($dados)){
		    
		    foreach($dados as $key => $value){
			    
			    $row = $this->buildParams($dados[$key]);
			    
			    try{
			        
					self::controlTransaction('begin');
					
					$prodExist = $this->entityManager->getConnection()->fetchAssoc(self::GET_CDPROD,$row);
					$prodExist = $prodExist['CDPRODUTO'];
					
					if($prodExist){
					    $row[':CDPRODUTO'] = $prodExist;
					    $row[':CDPRPAITABPR'] = $prodExist;
					    
					    
					    $prodHasTabPrice = $this->entityManager->getConnection()->fetchAssoc(self::GET_ITEMPRECO,$row);
                        
    					if($prodHasTabPrice){
                           $resultItemPreco = $this->entityManager->getConnection()->executeQuery(self::UPDATE_ITEMPRECO,$row);
                            
                            if(!$resultItemPreco){
                                $retorno['rowsError'] += 1;
    						    $retorno['logRowsError'] .= ' => ITEM PREÇO NÃO FOI ATUALIZADO! Linha: '. ($key+2) . PHP_EOL;
    						    $retorno['message'] .= ' => Linha: '. ($key+2) . PHP_EOL;
                            }
                            
                            if($row[':PRECODIF'] == 'S'){
                                if(!in_array($row[':CDPRODUTO'], $verifDelete)){
                                    $deletePrecoDifAll = $this->entityManager->getConnection()->executeQuery(self::DELETE_PRECOS_DIFERENCIADOS_ALL,$row);
                					if(!$deletePrecoDifAll){
                                        $retorno['rowsError'] += 1;
                                        $retorno['logRowsError'] .= ' => PREÇOS DIFERENCIADOS NÃO PODERAM SER DELETADOS PARA SEREM ATUALIZADOS!Linha: '. ($key+2) . PHP_EOL;
                                        $retorno['message'] .= ' => Linha: '. ($key+2) . PHP_EOL;
                                    }
                                    array_push($verifDelete, $row[':CDPRODUTO']);
                                }
                                
                                  if(($row[':IDPERVALORPR'] == 'P') && ($row[':VRPRECODIA'] < '99.90')){
                                        if($row[':IDDESCACREPR'] == 'D'){
                                            $desconto = (($row[':PRECO'] * $row[':VRPRECODIA']) / 100);
                                            $converte = bcdiv($desconto, 1, 2);
                                            $valorFinal = $row[':PRECO'] - $converte;
                                            $decimalConv = bcdiv($valorFinal, 1, 2);
                                            $row[':VRPRECODIF'] = $decimalConv;
                                          
                                    
                                        }else{
                                            $acrescimo = $row[':PRECO'] + ($row[':PRECO'] / 100 *  $row[':VRPRECODIA']);
                                            $substr = number_format($acrescimo, 2, '.', '.');
                                            $row[':VRPRECODIF'] = $substr;
                                        }
                                    }else if($row[':IDPERVALORPR'] == 'V'){
                                             if($row[':IDDESCACREPR'] == 'D'){
                                                $descontoValor = $row[':PRECO'] - $row[':VRPRECODIA'];
                                                $desconto1 = number_format($descontoValor, 2, '.', '.');
                                                $row[':VRPRECODIF'] = $desconto1;
                                                
                                             }else{
                                                $acrescimoValor = $row[':PRECO'] + $row[':VRPRECODIA'];
                                                $acrescimo1 = number_format($acrescimoValor, 2, '.', '.');
                                                $row[':VRPRECODIF'] = $acrescimo1;
                                                
                                             }
                                    }else if(($row[':IDPERVALORPR'] == 'P') && ($row[':VRPRECODIA'] > '99.90')){
                                        if($row[':IDDESCACREPR'] == 'D'){
                                           $variavel = 0.01;
                                           $trocaVariavel = bcdiv($variavel, 1, 2);
                                           $row[':VRPRECODIF'] = $trocaVariavel;
                                           $precoDia = $row[':VRPRECODIA'];
                                           $tratarPrecoDia = bcdiv($precoDia, 1, 2);
                                           $row[':VRPRECODIA'] = $tratarPrecoDia;
                                           
                                        }else{
                                            $acrescimoPercent = $row[':PRECO'] + ($row[':PRECO'] / 100 *  $row[':VRPRECODIA']);
                                            $acrescimo2 = bcdiv($acrescimoPercent, 1, 2);
                                            $row[':VRPRECODIF'] = $acrescimo2;
                                            $precoDia2 = $row[':VRPRECODIA'];
                                            $tratarPrecoDiaAcrescimo = bcdiv($precoDia2, 1, 2);
                                            $row[':VRPRECODIA'] = $tratarPrecoDiaAcrescimo;
                                        }
                                    } 
                                    
                                    
                                $diasSemana = $row[':NRDIASEMANPR'];  
                                foreach($diasSemana as $NRDIASEMANPR){
                                    $row[':NRDIASEMANPR'] = $NRDIASEMANPR;
                                    $insertPrecoDif = $this->entityManager->getConnection()->executeQuery(self::INSERT_PRECO_DIFERENCIADO,$row);
                                    if(!$insertPrecoDif){
                                        $retorno['rowsError'] += 1;
                                        $retorno['logRowsError'] .= ' => ITEM PREÇO DIFERENCIADO NÃO FOI CADASTRADO! Linha: '. ($key+2) . PHP_EOL;
                                        $retorno['message'] .= ' => Linha: '. ($key+2) . PHP_EOL;
                                    }
                                }
                            }
                            else{
                                 $deletePrecoDifAll = $this->entityManager->getConnection()->executeQuery(self::DELETE_PRECOS_DIFERENCIADOS_ALL,$row);
                            }
                            
                        }else {
                           
                            
                            $insertItemPreco = $this->entityManager->getConnection()->executeQuery(self::INSERT_ITEMPRECO,$row);
                            
                            if($insertItemPreco){
                                
                                if($row[':PRECODIF'] == 'S'){
                                    if(!in_array($row[':CDPRODUTO'], $verifDelete)){
                                        $deletePrecoDifAll = $this->entityManager->getConnection()->executeQuery(self::DELETE_PRECOS_DIFERENCIADOS_ALL,$row);
                    					if(!$deletePrecoDifAll){
                                            $retorno['rowsError'] += 1;
                                            $retorno['logRowsError'] .= ' => PREÇOS DIFERENCIADOS NÃO PODERAM SER DELETADOS PARA SEREM ATUALIZADOS!Linha: '. ($key+2) . PHP_EOL;
                                            $retorno['message'] .= ' => Linha: '. ($key+2) . PHP_EOL;
                                        }
                                        array_push($verifDelete, $row[':CDPRODUTO']);
                                    }
                                     
                                     if(($row[':IDPERVALORPR'] == 'P') && ($row[':VRPRECODIA'] < '99.90')){
                                        if($row[':IDDESCACREPR'] == 'D'){
                                            $desconto = (($row[':PRECO'] * $row[':VRPRECODIA']) / 100);
                                            $converte = bcdiv($desconto, 1, 2);
                                            $valorFinal = $row[':PRECO'] - $converte;
                                            $decimalConv = bcdiv($valorFinal, 1, 2);
                                            $row[':VRPRECODIF'] = $decimalConv;
                                          
                                    
                                        }else{
                                            $acrescimo = $row[':PRECO'] + ($row[':PRECO'] / 100 *  $row[':VRPRECODIA']);
                                            $substr = number_format($acrescimo, 2, '.', '.');
                                            $row[':VRPRECODIF'] = $substr;
                                        }
                                    }else if($row[':IDPERVALORPR'] == 'V'){
                                             if($row[':IDDESCACREPR'] == 'D'){
                                                $descontoValor = $row[':PRECO'] - $row[':VRPRECODIA'];
                                                $desconto1 = number_format($descontoValor, 2, '.', '.');
                                                $row[':VRPRECODIF'] = $desconto1;
                                                
                                             }else{
                                                $acrescimoValor = $row[':PRECO'] + $row[':VRPRECODIA'];
                                                $acrescimo1 = number_format($acrescimoValor, 2, '.', '.');
                                                $row[':VRPRECODIF'] = $acrescimo1;
                                                
                                             }
                                    }else if(($row[':IDPERVALORPR'] == 'P') && ($row[':VRPRECODIA'] > '99.90')){
                                        if($row[':IDDESCACREPR'] == 'D'){
                                           $variavel = 0.01;
                                           $trocaVariavel = bcdiv($variavel, 1, 2);
                                           $row[':VRPRECODIF'] = $trocaVariavel;
                                           $precoDia = $row[':VRPRECODIA'];
                                           $tratarPrecoDia = bcdiv($precoDia, 1, 2);
                                           $row[':VRPRECODIA'] = $tratarPrecoDia;
                                           
                                        }else{
                                            $acrescimoPercent = $row[':PRECO'] + ($row[':PRECO'] / 100 *  $row[':VRPRECODIA']);
                                            $acrescimo2 = bcdiv($acrescimoPercent, 1, 2);
                                            $row[':VRPRECODIF'] = $acrescimo2;
                                            $precoDia2 = $row[':VRPRECODIA'];
                                            $tratarPrecoDiaAcrescimo = bcdiv($precoDia2, 1, 2);
                                            $row[':VRPRECODIA'] = $tratarPrecoDiaAcrescimo;
                                        }
                                        
                                    } 
                                   
                                 
                                    
                                    $diasSemana = $row[':NRDIASEMANPR'];
                                    foreach($diasSemana as $NRDIASEMANPR){
                                        $row[':NRDIASEMANPR'] = $NRDIASEMANPR;
                                        $insertPrecoDif = $this->entityManager->getConnection()->executeQuery(self::INSERT_PRECO_DIFERENCIADO,$row);
                                        if(!$insertPrecoDif){
                                            $retorno['rowsError'] += 1;
                                            $retorno['logRowsError'] .= ' => ITEM PREÇO DIFERENCIADO NÃO FOI CADASTRADO! Linha: '. ($key+2) . PHP_EOL;
                                            $retorno['message'] .= ' => Linha: '. ($key+2) . PHP_EOL;
                                        }
                                    }
                                }
                                else{
                                     $deletePrecoDifAll = $this->entityManager->getConnection()->executeQuery(self::DELETE_PRECOS_DIFERENCIADOS_ALL,$row);
                                }
                            }
                            
                            if(!$insertItemPreco){
                                $retorno['rowsError'] += 1;
    						    $retorno['logRowsError'] .= ' => ITEM PREÇO NÃO PODE SER CADASTRADO! Linha: '. ($key+2) . PHP_EOL;
    						    $retorno['message'] .= ' => Linha: '. ($key+2) . PHP_EOL;
                            }
                        }   
                        
					}else{
					    $retorno['rowsError'] += 1;
					    $retorno['logRowsError'] .= ' => Código de produto não está cadastrado! Linha: '. ($key+2) . PHP_EOL;
					    $retorno['message'] .= 'Linha: '. ($key+2) . PHP_EOL;
					} 
					
					self::controlTransaction('commit');
					
				}catch(\Exception $e){
					$retorno['rowsError'] += 1;
					$retorno['logRowsError'] .= ' => NÃO FOI INSERIDO!' . PHP_EOL . "Erro ao executar operação!" . $e->getMessage(). PHP_EOL;	
					self::controlTransaction('rollback');
				}
			}
			unset($verifDelete);
		}else{
			$retorno['status'] = false;
			$retorno['message'] = "Sem dados para inserir ou atualizar!" .PHP_EOL;
		}
		if($retorno['rowsError'] === 0){
		    $retorno['rowsSucess'] += 1;
		    $retorno['logRowsSucess'] .= ' => PREÇOS INSERIDOS E ATUALIZADOS COM SUCESSO!' . PHP_EOL;
		}
		  
		return $retorno;
	}
     
    private function buildParams($row){
        $params = array();
        $params[':CDTABEPREC']   = array_key_exists('CDTABEPREC', $row) ? $row['CDTABEPREC']  : null; 
        $params[':DTINIVGPREC']  = array_key_exists('DTINIVGPREC', $row) ? $row['DTINIVGPREC']  : null; 
        $params[':DTFINVGPREC']  = array_key_exists('DTFINVGPREC', $row) ? $row['DTFINVGPREC']  : null; 
        $params[':CDPRODUTO']    = array_key_exists('CDPRODUTO', $row) ? $row['CDPRODUTO']  : null; 
        $params[':CDPRPAITABPR'] = array_key_exists('CDPRODUTO', $row) ? $row['CDPRODUTO']  : null; 
        $params[':NMPRODUTO']    = array_key_exists('NMPRODUTO', $row) ? $row['NMPRODUTO'] : null;
        $params[':PRECO']        = array_key_exists('PRECO', $row) ? $this->valorBD($row['PRECO']) : null;  
        $params[':PRECOSUG']     = array_key_exists('PRECOSUG', $row) ? $this->valorBD($row['PRECOSUG']) : null; 
        $params[':PRECOSUB']     = array_key_exists('PRECOSUB', $row) ? $this->valorBD($row['PRECOSUB']) : null; 
        $params[':PRECOCALC']    = array_key_exists('PRECOCALC', $row) ? $this->valorBD($row['PRECOCALC']) : null; 
        $params[':HRINI']        = array_key_exists('HRINI', $row) ? str_replace(":", "", $row['HRINI']) : null; 
        $params[':HRFIN']        = array_key_exists('HRFIN', $row) ? str_replace(":", "", $row['HRFIN']) : null;
        $params[':PRECODIF']     = array_key_exists('PRECODIF', $row) ? $row['PRECODIF'] : null; 
        $params[':NRDIASEMANPR'] = array_key_exists('NRDIASEMANPR', $row) ? explode("_", $row['NRDIASEMANPR']) : null;
        $params[':CDTIPOCONS']   = array_key_exists('CDTIPOCONS', $row) ? $row['CDTIPOCONS'] : null;
        $params[':CDTIPOCONSPD'] = array_key_exists('CDTIPOCONS', $row) ? $row['CDTIPOCONS'] : null; 
        $params[':VRPRECODIA']   = array_key_exists('VRPRECODIA', $row) ? $this->valorBD($row['VRPRECODIA']) : null;
        $params[':IDDESCACREPR'] = array_key_exists('IDDESCACREPR', $row) ? $row['IDDESCACREPR'] : null;   
        $params[':IDPERVALORPR'] = array_key_exists('IDPERVALORPR', $row) ? $row['IDPERVALORPR'] : null;  
        $params[':IDVISUACUPOM'] = array_key_exists('IDVISUACUPOM', $row) ? $row['IDVISUACUPOM'] : null;  
        $params[':HRINIPRECDIA'] = array_key_exists('HRINIPRECDIA', $row) ? str_replace(":", "", $row['HRINIPRECDIA']) : null;
        $params[':HRFINPRECDIA'] = array_key_exists('HRFINPRECDIA', $row) ? str_replace(":", "", $row['HRFINPRECDIA']) : null;
        $params[':DTINIVALPREC'] = array_key_exists('DTINIVALPREC', $row) ? $row['DTINIVALPREC'] : null;  
        $params[':DTFINVALPREC'] = array_key_exists('DTFINVALPREC', $row) ? $row['DTFINVALPREC'] : null;
        $params[':VRPRECODIF']   = array_key_exists('VRPRECODIF', $row) ? $row['VRPRECODIF'] : null;
        $params[':IDPRECVARIA']  =  'N'; 
        $params[':IDPRODPROMOC'] =  'N'; 
        $params[':NRORG'] = $this->environment->getNrOrgTrab();
        return $params;
	}
	
	private function valorBD($valorAplicado){
    	
    	$posVirgula = strpos( $valorAplicado, "," );
    	$posPont = strpos( $valorAplicado, "." );
    
    	if (!$posVirgula === false && !$posPont === false) {
    		$valor = str_replace("." , "" , $valorAplicado ); // Primeiro tira os pontos
    		$valorAplicado2 = str_replace(',','.',$valor);
    	}else if(!$posVirgula === false && $posPont === false){
    		$valorAplicado2 = str_replace(',','.',$valorAplicado);
    	}else {
    		$valorAplicado2 = $valorAplicado;
    	}
    	
    	return $valorAplicado2;
	}
    
    const GET_CDPROD = "
        SELECT CDPRODUTO FROM PRODUTO
            WHERE CDARVPROD = :CDPRODUTO
    ";

    const GET_ITEMPRECO = "
      SELECT CDPRODUTO FROM ITEMPRECOGER
            WHERE CDTABEPREC = :CDTABEPREC AND
                DTINIVGPREC = :DTINIVGPREC AND
                CDPRODUTO = :CDPRODUTO";
    
    const GET_ITEM_PRECODIA = "
        SELECT * FROM ITEMPRECODIAGER 
            WHERE 
                CDTABEPREC  = :CDTABEPREC AND
                CDPRODUTO   = :CDPRODUTO AND
                DTINIVGPREC = :DTINIVGPREC AND
                NRDIASEMANPR = :NRDIASEMANPR 
        ";  
    
    const GET_PRECO_DIFERENCIADO = "
        SELECT * FROM ITEMPRECODIAGER 
            WHERE 
                CDTABEPREC   = :CDTABEPREC AND
                CDPRODUTO    = :CDPRODUTO AND
                DTINIVGPREC  = :DTINIVGPREC AND
                NRDIASEMANPR = :NRDIASEMANPR AND             
                IDDESCACREPR = :IDDESCACREPR AND
                IDPERVALORPR = :IDPERVALORPR AND
                NRORG        = :NRORG    AND
                CDTIPOCONSPD = :CDTIPOCONSPD
        ";   
    
    const INSERT_ITEMPRECO = "
        INSERT INTO ITEMPRECOGER
          (CDTABEPREC, DTINIVGPREC, CDPRODUTO, VRPRECITEM, VRCUSTITEM, VRPRESUGITEM, VRPRECITEMCL, 
          IDPRECVARIA, IDPRODPROMOC, CDPRPAITABPR, HRINIVENPROD, HRFIMVENPROD, NRORG)
        VALUES
          (:CDTABEPREC,:DTINIVGPREC,:CDPRODUTO,:PRECO, :PRECOCALC, :PRECOSUG ,:PRECOSUB,
         :IDPRECVARIA, :IDPRODPROMOC,:CDPRPAITABPR, :HRINI, :HRFIN , :NRORG)
    	";
	
	const INSERT_PRECO_DIFERENCIADO = "
	    INSERT INTO ITEMPRECODIAGER 
	        (CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDPRPAITABPR, 
	            NRDIASEMANPR, HRINIPRECDIA, HRFINPRECDIA, VRPRECODIA, IDPERVALORPR, 
	            IDDESCACREPR, DTINIVALPREC, DTFINVALPREC, CDTIPOCONSPD,
	            IDVISUACUPOM, NRORG, VRPRECODIF)
            VALUES (
                 :CDTABEPREC, :DTINIVGPREC, :CDPRODUTO, :CDPRPAITABPR,
                :NRDIASEMANPR, :HRINIPRECDIA, :HRFINPRECDIA, :VRPRECODIA, :IDPERVALORPR,
                :IDDESCACREPR, :DTINIVALPREC, :DTFINVALPREC, :CDTIPOCONS,
                :IDVISUACUPOM, :NRORG, :VRPRECODIF)
	";
	
	const UPDATE_ITEMPRECO = "
        UPDATE ITEMPRECOGER SET
          VRPRECITEM   = :PRECO,
          VRCUSTITEM   = :PRECOCALC,
          VRPRESUGITEM = :PRECOSUG,
          IDPRECVARIA  = :IDPRECVARIA,
          VRPRECITEMCL = :PRECOSUB,
          IDPRODPROMOC = :IDPRODPROMOC,
          CDPRPAITABPR = :CDPRPAITABPR,
          HRINIVENPROD = :HRINI,
          HRFIMVENPROD = :HRFIN
        
        WHERE  CDPRODUTO    = :CDPRODUTO
          AND CDTABEPREC   = :CDTABEPREC 
          AND DTINIVGPREC  = :DTINIVGPREC
          AND NRORG        = :NRORG";
      
    const UPDATE_PRECO_DIFERENCIADO = "
      UPDATE ITEMPRECODIAGER 
        SET VRPRECODIA = :VRPRECODIA,
            DTFINVALPREC = :DTFINVALPREC,
            IDPERVALORPR = :IDPERVALORPR,
            IDDESCACREPR = :IDDESCACREPR,
            HRFINPRECDIA = :HRFINPRECDIA,
            IDVISUACUPOM = :IDVISUACUPOM,
            VRPRECODIF = :VRPRECODIF
           
        WHERE 
              CDTABEPREC    = :CDTABEPREC   AND
              DTINIVGPREC   = :DTINIVGPREC  AND
              CDPRODUTO     = :CDPRODUTO    AND
              CDPRPAITABPR  = :CDPRPAITABPR AND
              NRDIASEMANPR  = :NRDIASEMANPR AND
              HRINIPRECDIA  = :HRINIPRECDIA AND
              DTINIVALPREC  = :DTINIVALPREC AND
              CDTIPOCONSPD  = :CDTIPOCONSPD AND
              NRORG         = :NRORG
    	";
    
    const DELETE_PRECOS_DIFERENCIADOS_DIA = "
        DELETE FROM ITEMPRECODIAGER
        WHERE
            NRORG =             :NRORG
            AND   CDTABEPREC  = :CDTABEPREC
            AND   CDPRODUTO   = :CDPRODUTO
            AND   DTINIVGPREC = :DTINIVGPREC
            AND  NRDIASEMANPR = :NRDIASEMANPR
            AND  CDTIPOCONSPD = :CDTIPOCONSPD
    ";
    const DELETE_PRECOS_DIFERENCIADOS_ALL = "
        DELETE FROM ITEMPRECODIAGER
        WHERE
            NRORG =             :NRORG
            AND   CDTABEPREC  = :CDTABEPREC
            AND   CDPRODUTO   = :CDPRODUTO
            AND   DTINIVGPREC = :DTINIVGPREC
            
    ";
    
}